import 'package:bea_flutter_package/bea_services/core/bea_network_manager.dart';
import 'package:bea_flutter_package/bea_services/core/bea_service_manager.dart';
import 'package:f_logs/f_logs.dart';

class BeaFlutterPackage {

  BeaNetworkManager? _beaNetworkManager;

  BeaFlutterPackage(){
    LogsConfig config = getLoggerConfig();

    FLog.applyConfigurations(config);
  }

  BeaNetworkManager? getBeaNetworkManager() {
    if(_beaNetworkManager == null){
      _beaNetworkManager = new BeaNetworkManager();
    }
    return _beaNetworkManager;
  }

  BeaServiceManager getBeaServiceInstance(String url) {
    return new BeaServiceManager(this, url);
  }

  LogsConfig getLoggerConfig(){
    return LogsConfig()
      ..isDebuggable = true
      ..customClosingDivider = "|"
      ..customOpeningDivider = "|"
      ..csvDelimiter = ";"
      ..isLogsEnabled = true
      ..encryptionEnabled = false
      ..encryptionKey = ""
      ..formatType = FormatType.FORMAT_CURLY
      ..logLevelsEnabled = [LogLevel.INFO, LogLevel.DEBUG, LogLevel.ERROR, LogLevel.WARNING, LogLevel.FATAL]
      ..dataLogTypes = [
        DataLogType.DEVICE.toString(),
        DataLogType.NETWORK.toString(),
      ]
      ..timestampFormat = TimestampFormat.TIME_FORMAT_READABLE;
  }
}
